# coding: utf-8

require_relative 'spec_helper'

RSpec.describe 'IyziPay' do
  before :all do
    @options = IyziPay::Options.new
    @options.api_key = YAML.load_file('.secrets.yml')['test']['api_key']
    @options.secret_key = YAML.load_file('.secrets.yml')['test']['secret_key']
    @options.base_url = YAML.load_file('.secrets.yml')['test']['base_url']
  end

  it 'should initialize pecco' do
    buyer = {
        id: 'BY789',
        name: 'John',
        surname: 'Doe',
        identityNumber: '74300864791',
        email: 'email@email.com',
        gsmNumber: '+905350000000',
        registrationDate: '2013-04-21 15:12:09',
        lastLoginDate: '2015-10-05 12:43:35',
        registrationAddress: 'Nidakule Göztepe, Merdivenköy Mah. Bora Sok. No:1',
        city: 'Istanbul',
        country: 'Turkey',
        zipCode: '34732',
        ip: '85.34.78.112'
    }
    address = {
        address: 'Nidakule Göztepe, Merdivenköy Mah. Bora Sok. No:1',
        zipCode: '34732',
        contactName: 'John Doe',
        city: 'Istanbul',
        country: 'Turkey'
    }

    item1 = {
        id: 'BI101',
        name: 'Binocular',
        category1: 'Collectibles',
        category2: 'Accessories',
        itemType: IyziPay::Model::BasketItemType::PHYSICAL,
        price: '30000',
    }
    item2 = {
        id: 'BI102',
        name: 'Game code',
        category1: 'Game',
        category2: 'Online Game Items',
        itemType: IyziPay::Model::BasketItemType::VIRTUAL,
        price: '50000',
    }
    item3 = {
        id: 'BI103',
        name: 'Usb',
        category1: 'Electronics',
        category2: 'Usb / Cable',
        itemType: IyziPay::Model::BasketItemType::PHYSICAL,
        price: '20000',
    }
    request = {
        locale: IyziPay::Model::Locale::TR,
        conversationId: '123456789',
        price: '100000',
        paidPrice: '120000',
        basketId: 'B67832',
        paymentGroup: IyziPay::Model::PaymentGroup::LISTING,
        callbackUrl: 'https://www.example.com/callback',
        currency: IyziPay::Model::Currency::IRR,
        buyer: buyer,
        billingAddress: address,
        shippingAddress: address,
        basketItems: [item1, item2, item3]
    }
    pecco_initialize = IyziPay::Model::PeccoInitialize.new.create(request, @options)
    begin
      $stderr.puts pecco_initialize.inspect
      threeds_initialize_dict = JSON.parse(pecco_initialize)
      unless threeds_initialize_dict['htmlContent'].nil?
        $stderr.puts Base64.decode64(threeds_initialize_dict['htmlContent']).inspect
      end
    rescue
      $stderr.puts 'oops'
      raise
    end
  end

  it 'should create pecco payment' do
    request = {
        locale: IyziPay::Model::Locale::TR,
        conversationId: '123456789',
        token: 'token',
    }
    threeds_payment = IyziPay::Model::PeccoPayment.new.create(request, @options)
    begin
      $stderr.puts threeds_payment.inspect
    rescue
      $stderr.puts 'oops'
      raise
    end
  end

  after :each do
  end
end
