# coding: utf-8

require_relative 'spec_helper'

RSpec.describe 'IyziPay' do
  before :all do
    @options = IyziPay::Options.new
    @options.api_key = YAML.load_file('.secrets.yml')['test']['api_key']
    @options.secret_key = YAML.load_file('.secrets.yml')['test']['secret_key']
    @options.base_url = YAML.load_file('.secrets.yml')['test']['base_url']
  end

  it 'should retrieve payout completed transactions' do
    request = {
        locale: IyziPay::Model::Locale::TR,
        conversationId: '123456789',
        date: '2016-01-22 19:13:00'
    }
    refund = IyziPay::Model::PayoutCompletedTransactionList.new.retrieve(request, @options)
    begin
      $stderr.puts refund.inspect
    rescue
      $stderr.puts 'oops'
      raise
    end
  end

  it 'should retrieve bounced bank transfers' do
    request = {
        locale: IyziPay::Model::Locale::TR,
        conversationId: '123456789',
        date: '2016-01-22 19:13:00'
    }
    refund = IyziPay::Model::BouncedBankTransferList.new.retrieve(request, @options)
    begin
      $stderr.puts refund.inspect
    rescue
      $stderr.puts 'oops'
      raise
    end
  end

  after :each do
  end
end
